`timescale 1ns / 1ps 

module add(
    input [31:0] x,
    input [31:0] y,
	input clk,
    output reg [31:0] z
    );

reg [23:0] ma;
reg [23:0] mb;
reg [24:0] mc;
reg [7:0] exp;
reg [2:0] choice;
reg [31:0] limit;

always @(posedge clk)
begin
	if(x[31] == y[31])
	begin
		choice = 0;
		z[31] = x[31]; // semn
	end
	else if(x[31] != y[31])
		begin
			if(x[30:23] > y[30:23])
			begin
				choice = 1;
				z[31] = x[31];
			end
			else if(x[30:23] < y[30:23])
			begin
				choice = 2;
				z[31] = y[31];
			end
			else
				begin
					if(x[22:0] > y[22:0])
					begin
						choice = 1;
						z[31] = x[31];
					end
					else 
					begin
						choice = 2;
						z[31] = y[31];
					end
				end
		end
	
	if (x==0)
		z = y;
	else if (y==0)
		z = x;
	   
	else begin
		ma = {1'b1, x[22:0]};
		mb = {1'b1, y[22:0]};
		
		if (x[30:23] < y[30:23]) begin
		    exp = y[30:23] - x[30:23];
			ma = ma >> exp;
			z[30:23] = y[30:23] + 1;
		end else begin
			exp = x[30:23] - y[30:23];
			mb = mb >> exp;
			z[30:23] = x[30:23] + 1;
		end
		
		if ( choice == 0)
			mc = ma + mb;
		else if (choice == 1)
			mc = ma - mb;
		else
			mc = mb - ma;
		
		limit = 0;
		if (mc != 0) begin
			while ((mc[24] == 1'b0) && limit < 32) begin
				mc = mc << 1;
				z[30:23] = z[30:23] - 1;
				limit = limit + 1;
			end
		end
		z[22:0] = mc[23:1];
	end
end	 
	 


endmodule
