`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    00:28:32 10/18/2011 
// Design Name: 
// Module Name:    fpaddition 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module fpaddition(
    input [31:0] a,
    input [31:0] b,
    input complement,
    output reg [31:0] c
    );

	reg [31:0] b2;
	wire [7:0] extra;
	wire [7:0] extra2;
	reg [47:0] ma;
	reg [47:0] mb;
	reg [47:0] mc;
	reg [7:0] exp;
	wire [22:0] b2n;
	wire [22:0] c2n;
	normalizer normalize1({24'd0, 1 << 24 - {1'b1, b[22:0]}},
				b2n, extra);
	normalizer normalize2(mc, c2n, extra2);
	always @ (a or b) begin
		if (complement) begin
			b2[31] = ~b[31];			
			b2[22:0] = b2n;
			b2[30:23] = b[30:23] + extra;
		end else begin
			b2 = b;
		end
		ma[47:0] = {1'b1, a[22:0], 24'd0};
		mb[47:0] = {1'b1, b[22:0], 24'd0};
		if (a[30:23] < b2[30:23]) begin
			ma = ma >> (b2[30:23] - a[30:23]);			
			exp = b2[30:23];
			c[31] = b2[31];
		end else if (a[30:23] == b2[30:23]) begin
			c[31] = a[22:0] > b2[22:0] ? a[31] : b2[31];
			exp = a[30:23];
		end else begin
			mb = mb >> (a[30:23] - b2[30:23]);
			exp = a[30:23];	
			c[31] = a[31];
		end
		mc = ma + mb;		
		c[22:0] = c2n;
		c[30:23] = exp + extra2;
	end

endmodule
