module prilib(
	      cu,
	      priout
	      );
   input [22527:0] cu;
   output [2047:0]  priout;
   reg [2047:0]     priout;

   reg [11:0] 	    i;
   reg [4:0] 	    j;

   reg [11:0] 	     min_val;
   reg [11:0] 	     min_pos;
   reg [10:0] 	     temp;

   always @ (cu) begin
      priout = 0;
      min_val = cu[10:0];
      min_pos = 0;
      for (i = 1; i < 2048; i = i + 1) begin
	 for (j = 0; j < 11; j = j + 1)
	   temp[j] = cu[i * 11 + j];
	 if (temp < min_val) begin
	    min_val = temp;
	    min_pos = i;
	 end
      end
      priout[min_pos] = 1;      
   end

endmodule
